## Script (Python) "cpsdocument_edit"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Id: student_edit.py 486 2006-09-06 10:09:39Z joachim $
"""
return Info about the current Student
"""
request = context.REQUEST
form = request.form
fget = form.get
info = {}
wf = context.portal_workflow
catalog = context.portal_catalog
student_wf_states = wf.waeup_student_wf.states.keys()
info['wf_states'] = student_wf_states
info['wf_states'][0] = " ----- "
mtool = context.portal_membership
member = mtool.getAuthenticatedMember()
lt = context.portal_layouts
pr = context.portal_registration
path_info = request.get('PATH_INFO').split('/')
roles = member.getRoles()
is_manager = 'Manager' in roles or 'SectionManager' in roles
validate = request.has_key("cpsdocument_edit_button")
items = []
default = {'search_mode': 'name', 
        'review_state': 'admission_applied ', 
        'search_string': ''
        }
        
rend,psm,ds = lt.renderLayout(layout_id= 'student_search',
                      schema_id= 'student_search',
                      context=context,
                      mapping=validate and request,
                      ob=default,
                      layout_mode='edit',
                      formaction="searchStudents"
                      )
if psm == '':
    return context.students_manager_view(rendered = rend,
                             psm = psm,
                             #psm = "%s, %s" % (psm,ds),
                             students = items,
                             is_manager = is_manager,
                             )
what = ds.get('search_mode')
state = ds.get('review_state')
term = ds.get('search_string')
if state == " ----- ":
    state = ''
if not term and what in ('student_edit','jamb_id','name','matric_no'):
    return context.students_manager_view(rendered = rend,
                             psm = "You must specify a search string",
                             #psm = "%s, %s" % (psm,ds),
                             students = items,
                             is_manager = is_manager,
                             )
onlyreview = state and what == "review_state"
items = []
res = []
portal_type_query = {'query':['Student','StudentApplication','StudentPersonal']}
if onlyreview:
    res = catalog(portal_type=portal_type_query,
                  review_state=state)
elif what == "student_id":
    res = catalog(portal_type='Student',
                  id = term.strip())
elif what == "jamb_id":
    res = catalog(portal_type='StudentApplication',
                  SearchableText="%s*" % term.strip().lower())
elif what == "matric_no":
    res = catalog(portal_type='StudentClearance',
                  SearchableText="%s*" % term.strip().lower())
elif what == "name":
    res = catalog(portal_type=portal_type_query,
                  SearchableText="%s*" % term.strip())
if res:
    for r in res:
        row = {}
        if r.portal_type in ("StudentApplication","StudentPersonal"):
            items.append(r.getObject().aq_parent)
        else:
            items.append(r.getObject())
students = []
if items:
    for item in items:
        students.append(context.getStudentInfo(item))
return context.students_manager_view(rendered = rend,
                             psm = "%d matching Students found" % len(items),
                             #psm = "%s, %s" % (psm,ds),
                             students = students,
                             is_manager = is_manager,
                             )
